VERSION 5.00
Begin VB.UserControl lst 
   Alignable       =   -1  'True
   AutoRedraw      =   -1  'True
   CanGetFocus     =   0   'False
   ClientHeight    =   3600
   ClientLeft      =   0
   ClientTop       =   0
   ClientWidth     =   4800
   ScaleHeight     =   240
   ScaleMode       =   3  'Pixel
   ScaleWidth      =   320
End
Attribute VB_Name = "lst"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit
Private Item() As String
Private Index As Long
Private Selected As Long
Private lngValue As Long, lngMax As Long
Event Click(Button As Integer)
Public Property Get BackColor() As OLE_COLOR
Attribute BackColor.VB_Description = "Returns/sets the background color used to display text and graphics in an object."
    BackColor = UserControl.BackColor
End Property
Public Property Let BackColor(ByVal New_BackColor As OLE_COLOR)
    UserControl.BackColor() = New_BackColor
    PropertyChanged "BackColor"
    Draw
End Property
Public Property Get Font() As Font
Attribute Font.VB_Description = "Returns a Font object."
Attribute Font.VB_UserMemId = -512
    Set Font = UserControl.Font
End Property
Public Property Set Font(ByVal New_Font As Font)
    Set UserControl.Font = New_Font
    PropertyChanged "Font"
    Draw
End Property
Public Property Get ForeColor() As OLE_COLOR
Attribute ForeColor.VB_Description = "Returns/sets the foreground color used to display text and graphics in an object."
    ForeColor = UserControl.ForeColor
End Property
Public Property Let ForeColor(ByVal New_ForeColor As OLE_COLOR)
    UserControl.ForeColor() = New_ForeColor
    PropertyChanged "ForeColor"
    Draw
End Property
Private Sub UserControl_InitProperties()
    Set UserControl.Font = Ambient.Font
End Sub


Private Sub UserControl_ReadProperties(PropBag As PropertyBag)
    UserControl.BackColor = PropBag.ReadProperty("BackColor", &H8000000F)
    Set UserControl.Font = PropBag.ReadProperty("Font", Ambient.Font)
    UserControl.ForeColor = PropBag.ReadProperty("ForeColor", &H80000012)
End Sub
Private Sub UserControl_Resize()
    Height = ((ScaleHeight \ TextHeight("A")) * TextHeight("A")) * Screen.TwipsPerPixelY
    Draw
End Sub
Private Sub UserControl_Show()
    Draw
End Sub
Private Sub UserControl_WriteProperties(PropBag As PropertyBag)
    Call PropBag.WriteProperty("BackColor", UserControl.BackColor, &H8000000F)
    Call PropBag.WriteProperty("Font", UserControl.Font, Ambient.Font)
    Call PropBag.WriteProperty("ForeColor", UserControl.ForeColor, &H80000012)
End Sub
Public Sub ItemAdd(strText As String)
    strText = Replace(strText, vbCrLf, "...")
    On Error GoTo First
    ReDim Preserve Item(UBound(Item) + 1)
    Item(UBound(Item)) = strText
    Draw
    Exit Sub
First:
    ReDim Item(0)
    Item(UBound(Item)) = strText
    Draw
End Sub
Public Sub ItemClear()
    Erase Item()
    Draw
End Sub
Public Sub Draw()
    Cls
    On Error Resume Next
    For Index = lngValue To (ScaleHeight \ TextHeight("A")) + lngValue
        If Index > UBound(Item) Then Exit For
        If Index < LBound(Item) Then Exit For
        If Index = Selected Then
            Dim Sel
            Sel = (Selected - lngValue) * TextHeight("A")
            Line (0, Sel)-(ScaleWidth, Sel + TextHeight("A")), vb3DLight, BF
            CurrentX = CurrentX - ScaleWidth
            CurrentY = CurrentY - TextHeight("A")
        End If
        Print " " & Item(Index)
    Next
    Refresh
    If UBound(Item) <= (ScaleHeight \ TextHeight("A")) Then
        lngMax = 0
    Else
        lngMax = UBound(Item) - (ScaleHeight \ TextHeight("A")) + 1
    End If
End Sub
Private Sub UserControl_MouseDown(Button As Integer, Shift As Integer, X As Single, Y As Single)
    On Error Resume Next
    If Y \ TextHeight("A") + lngValue > UBound(Item) Then Exit Sub
    Selected = Y \ TextHeight("A") + lngValue
    Draw
    RaiseEvent Click(Button)
End Sub
Public Sub SetValue(NewValue As Long)
    lngValue = NewValue
    Draw
End Sub
Public Function GetAll() As Long
    On Error Resume Next
    GetAll = UBound(Item)
End Function
Public Function GetMax() As Long
    GetMax = lngMax
End Function
Public Function GetSelected() As Long
    GetSelected = Selected
End Function
Public Function GetText() As String
    On Error Resume Next
    GetText = Item(Selected)
End Function
